100 DEFINT I-N:KEY OFF:OPTION BASE 1:GOSUB 730
110 PRINT"---  Bear & Verruijt - Groundwater Modeling"
120 PRINT"---  Plane steady Flow with Infiltration and Leakage"
130 PRINT"---  Finite Element Method":PRINT"---  Program 10.3"
140 PRINT"---  Quadrangular elements, input from dataset"
150 DIM XJ(4),YJ(4),B(3),C(3),D(3),KS(4,3)
160 DIM X(300),Y(300),IP(300),F(300),FA(300),Q(300)
170 DIM NP(250,4),T(250),PP(250),CC(250)
180 DIM U(300),V(300),W(300),P(300,11),R(300,11),KP(300,11):NZ=11
190 PRINT:PRINT:PRINT"Reading data":PRINT:INPUT"Name of dataset ";A$
200 OPEN "I",1,A$:INPUT #1,N,M
210 FOR I=1 TO N:INPUT #1,X(I),Y(I),IP(I),F(I),FA(I),Q(I):NEXT I
220 FOR J=1 TO M:INPUT #1,NP(J,1),NP(J,2),NP(J,3),NP(J,4),T(J),PP(J),CC(J)
230 NEXT J:CLOSE 1:FOR I=1 TO 4:FOR J=1 TO 3:K=I+J-1:IF K>4 THEN K=K-4
240 KS(I,J)=K:NEXT J,I:GOSUB 730:PRINT"Generation of pointer matrix"
250 FOR I=1 TO N:KP(I,1)=I:KP(I,NZ)=1:NEXT I
260 PRINT"   Element ...... ";:FOR J=1 TO M:PRINT J;
270 FOR K=1 TO 4:KK=NP(J,K):FOR L=1 TO 4:LL=NP(J,L)
280 IA=0:FOR II=1 TO KP(KK,NZ):IF KP(KK,II)=LL THEN IA=1
290 NEXT II:IF IA=0 THEN KB=KP(KK,NZ)+1:KP(KK,NZ)=KB:KP(KK,KB)=LL
300 IF KB=NZ THEN 720
310 NEXT L,K,J:PRINT:PRINT:EE=.00001
320 PRINT"Generation of system matrices":PRINT"   Element ...... ";
330 FOR J=1 TO M:PRINT J;:FOR KW=1 TO 4:ZX=0:ZY=0
340 FOR I=1 TO 3:K=NP(J,KS(KW,I)):XJ(I)=X(K):YJ(I)=Y(K)
350 ZX=ZX+X(K):ZY=ZY+Y(K):NEXT I:ZX=ZX/3:ZY=ZY/3
360 FOR I=1 TO 3:XJ(I)=XJ(I)-ZX:YJ(I)=YJ(I)-ZY:NEXT I
370 B(1)=YJ(2)-YJ(3):B(2)=YJ(3)-YJ(1):B(3)=YJ(1)-YJ(2)
380 C(1)=XJ(3)-XJ(2):C(2)=XJ(1)-XJ(3):C(3)=XJ(2)-XJ(1)
390 D(1)=XJ(2)*YJ(3)-XJ(3)*YJ(2):D(2)=XJ(3)*YJ(1)-XJ(1)*YJ(3)
400 D(3)=XJ(1)*YJ(2)-XJ(2)*YJ(1)
410 D=ABS(D(1)+D(2)+D(3)):IF D<EE THEN 540
420 DD=T(J)/(4*D):DE=1/(4*CC(J)*D)
430 XX=(XJ(1)*XJ(1)+XJ(2)*XJ(2)+XJ(3)*XJ(3))/12
440 XY=(XJ(1)*YJ(1)+XJ(2)*YJ(2)+XJ(3)*YJ(3))/12
450 YY=(YJ(1)*YJ(1)+YJ(2)*YJ(2)+YJ(3)*YJ(3))/12
460 FOR K=1 TO 3:KK=NP(J,KS(KW,K)):II=KP(KK,NZ):FOR LL=1 TO II:L=1
470 KV=KS(KW,L):IF NP(J,KV)=KP(KK,LL) THEN 490
480 L=L+1:IF L<4 THEN 470 ELSE 520
490 P(KK,LL)=P(KK,LL)+DD*(B(K)*B(L)+C(K)*C(L))
500 AA=XX*B(K)*B(L)+XY*(B(K)*C(L)+B(L)*C(K))+YY*C(K)*C(L)+D(K)*D(L)
510 R(KK,LL)=R(KK,LL)+DE*AA
520 NEXT LL,K
530 FOR I=1 TO 3:K=NP(J,KS(KW,I)):Q(K)=Q(K)+D*PP(J)/12:NEXT I
540 NEXT KW,J:PRINT:PRINT:EE=EE*EE
550 PRINT"Solution of equations":PRINT"   Iteration .... ";:IT=1
560 FOR I=1 TO N:IZ=KP(I,NZ):U(I)=0:IF IP(I)>0 THEN 590
570 U(I)=Q(I):FOR J=1 TO IZ:CC=R(I,J):L=KP(I,J)
580 U(I)=U(I)-(P(I,J)+CC)*F(L)+CC*FA(L):NEXT J
590 V(I)=U(I):NEXT I:UU=0:FOR I=1 TO N:UU=UU+U(I)*U(I):NEXT I
600 PRINT IT;:FOR I=1 TO N:W(I)=0:IZ=KP(I,NZ)
610 FOR J=1 TO IZ:W(I)=W(I)+(P(I,J)+R(I,J))*V(KP(I,J)):NEXT J,I
620 VW=0:FOR I=1 TO N:VW=VW+V(I)*W(I):NEXT I
630 AA=UU/VW:FOR I=1 TO N:IF IP(I)>0 THEN 650
640 F(I)=F(I)+AA*V(I):U(I)=U(I)-AA*W(I)
650 NEXT I:WW=0:FOR I=1 TO N:WW=WW+U(I)*U(I):NEXT I
660 BB=WW/UU:FOR I=1 TO N:V(I)=U(I)+BB*V(I):NEXT I:UU=WW
670 IT=IT+1:IF IT<=N AND UU>EE THEN 600
680 GOSUB 730:PRINT:A$="#####.###":FOR I=1 TO N
690 PRINT" x = ";:PRINT USING A$;X(I);:PRINT" -  y = ";
700 PRINT USING A$;Y(I);:PRINT" -  F = ";:PRINT USING A$;F(I):NEXT I
710 PRINT:END
720 GOSUB 730:PRINT"Pointer width (NZ) too small.":GOTO 710
730 CLS:LOCATE 1,30,1:COLOR 0,7:PRINT" Finite Elements - 3 ";:COLOR 7,0
740 COLOR 7,0:PRINT:PRINT:RETURN
