100 DEFINT I-N:KEY OFF:OPTION BASE 1:GOSUB 760
110 PRINT"---  Bear & Verruijt - Groundwater Modeling"
120 PRINT"---  Plane non-steady Groundwater Flow"
130 PRINT"---  Finite Element Method":PRINT"---  Program 10.5"
140 PRINT"---  Quadrangular elements, input from datafile"
150 PRINT"---  Solution by conjugate gradient method"
160 DIM XJ(4),YJ(4),B(3),C(3),D(3),KS(4,3)
170 DIM X(300),Y(300),IP(300),F(300),FA(300),Q(300),QA(300)
180 DIM NP(250,4),T(250),S(250),PP(250)
190 DIM U(300),V(300),W(300),P(300,11),KP(300,11):NZ=11
200 PRINT:PRINT:PRINT"Reading data":PRINT:INPUT"Name of datafile ";A$
210 OPEN "I",1,A$:INPUT #1,N,M,E
220 FOR I=1 TO N:INPUT #1,X(I),Y(I),IP(I),FA(I),Q(I):F(I)=FA(I):NEXT I
230 FOR J=1 TO M:INPUT #1,NP(J,1),NP(J,2),NP(J,3),NP(J,4),T(J),S(J),PP(J)
240 NEXT J:CLOSE 1:FOR I=1 TO 4:FOR J=1 TO 3:K=I+J-1:IF K>4 THEN K=K-4
250 KS(I,J)=K:NEXT J,I:GOSUB 760:PRINT"Generation of pointer matrix"
260 FOR I=1 TO N:KP(I,1)=I:KP(I,NZ)=1:NEXT I
270 PRINT"   Element ...... ";:FOR J=1 TO M:PRINT J;
280 FOR K=1 TO 4:KK=NP(J,K):FOR L=1 TO 4:LL=NP(J,L)
290 IA=0:FOR II=1 TO KP(KK,NZ):IF KP(KK,II)=LL THEN IA=1
300 NEXT II:IF IA=0 THEN KB=KP(KK,NZ)+1:KP(KK,NZ)=KB:KP(KK,KB)=LL
310 IF KB=NZ THEN 750
320 NEXT L,K,J:PRINT:PRINT:EE=.00001:EE=EE*EE:TN=0
330 PRINT"Generation of system matrix":PRINT"   Element ...... ";
340 FOR I=1 TO N:FOR J=1 TO NZ:P(I,J)=0:NEXT J:NEXT I
350 FOR J=1 TO M:PRINT J;:FOR KW=1 TO 4:ZX=0:ZY=0
360 FOR I=1 TO 3:K=NP(J,KS(KW,I)):XJ(I)=X(K):YJ(I)=Y(K)
370 ZX=ZX+X(K):ZY=ZY+Y(K):NEXT I:ZX=ZX/3:ZY=ZY/3
380 FOR I=1 TO 3:XJ(I)=XJ(I)-ZX:YJ(I)=YJ(I)-ZY:NEXT I
390 B(1)=YJ(2)-YJ(3):B(2)=YJ(3)-YJ(1):B(3)=YJ(1)-YJ(2)
400 C(1)=XJ(3)-XJ(2):C(2)=XJ(1)-XJ(3):C(3)=XJ(2)-XJ(1)
410 D(1)=XJ(2)*YJ(3)-XJ(3)*YJ(2):D(2)=XJ(3)*YJ(1)-XJ(1)*YJ(3)
420 D(3)=XJ(1)*YJ(2)-XJ(2)*YJ(1)
430 D=ABS(D(1)+D(2)+D(3)):IF D<EE THEN 520
440 DD=T(J)/(4*D):DE=S(J)*D/12
450 FOR K=1 TO 3:KK=NP(J,KS(KW,K)):II=KP(KK,NZ):FOR LL=1 TO II:L=1
460 KV=KS(KW,L):IF NP(J,KV)=KP(KK,LL) THEN 480
470 L=L+1:IF L<4 THEN 460 ELSE 490
480 P(KK,LL)=P(KK,LL)+DD*(B(K)*B(L)+C(K)*C(L))
490 NEXT LL,K
500 FOR I=1 TO 3:K=NP(J,KS(KW,I)):Q(K)=Q(K)+D*PP(J)/12:
510 QA(K)=QA(K)+DE:NEXT I
520 NEXT KW,J:PRINT:PRINT:PRINT"Time = ";TN:PRINT
530 INPUT"Time after next step ";TT:IT=1:DT=TT-TN:IF DT<=0 THEN 740
540 TN=TT:GOSUB 760
550 PRINT:PRINT"Solution of equations":PRINT"   Iteration ";
560 FOR I=1 TO N:U(I)=0:IZ=KP(I,NZ):IF IP(I)>0 THEN 590
570 U(I)=Q(I)+QA(I)*FA(I)/DT:FOR J=1 TO IZ:L=KP(I,J)
580 U(I)=U(I)-P(I,J)*F(L):NEXT J:U(I)=U(I)-QA(I)*F(I)/DT
590 V(I)=U(I):NEXT I:UU=0:FOR I=1 TO N:UU=UU+U(I)*U(I):NEXT I
600 PRINT IT;:FOR I=1 TO N:W(I)=0:IZ=KP(I,NZ)
610 FOR J=1 TO IZ:W(I)=W(I)+P(I,J)*V(KP(I,J)):NEXT J
620 W(I)=W(I)+QA(I)*V(I)/DT:NEXT I
630 VW=0:FOR I=1 TO N:VW=VW+V(I)*W(I):NEXT I
640 AA=UU/VW:FOR I=1 TO N:IF IP(I)>0 THEN 660
650 F(I)=F(I)+AA*V(I):U(I)=U(I)-AA*W(I)
660 NEXT I:WW=0:FOR I=1 TO N:WW=WW+U(I)*U(I):NEXT I
670 BB=WW/UU:FOR I=1 TO N:V(I)=U(I)+BB*V(I):NEXT I:UU=WW
680 IT=IT+1:IF IT<=N AND UU>EE THEN 600
690 FOR I=1 TO N:FA(I)=F(I):F(I)=FA(I):NEXT I
700 GOSUB 760:A$="#####.###":FOR I=1 TO N
710 PRINT" x = ";:PRINT USING A$;X(I);:PRINT"   -   y = ";
720 PRINT USING A$;Y(I);:PRINT"   -   F = ";:PRINT USING A$;FA(I)
730 NEXT I:PRINT"Time = ";TN:GOTO 530
740 PRINT:END
750 GOSUB 760:PRINT"Pointer width (NZ) too small.":GOTO 740
760 CLS:LOCATE 1,30,1:COLOR 0,7:PRINT" Finite Elements - 5 ";
770 COLOR 7,0:PRINT:PRINT:RETURN
