100 DEFINT I-N:KEY OFF:OPTION BASE 1:GOSUB 830
110 PRINT"---  Bear & Verruijt - Groundwater Modeling"
120 PRINT"---  Plane steady Groundwater Flow"
130 PRINT"---  Advection using numerical solution"
140 PRINT"---  Program 11.2 - Part 3"
150 PRINT"---  Stream function by finite elements":PRINT
160 DIM XJ(3),YJ(3),B(3),C(3),KS(4,3)
170 DIM X(250),Y(250),IP(250),F(250),Q(250),U(250),V(250),W(250)
180 DIM P(250,12),KP(250,12):NZ=12
190 DIM NP(250,4),T(250),QX(250),QY(250),FC(250),MP(100,2),AW(100),QW(100)
200 INPUT"Name of dataset ";N$:OPEN "I",1,N$:PRINT
210 INPUT#1,NLX,NLY,SXY,NSCR,N,M,MW
220 FOR I=1 TO N:INPUT#1,X(I),Y(I),IP(I),F(I),Q(I)
230 Q(I)=0:IF IP(I)=0 THEN F(I)=0
240 NEXT I
250 FOR J=1 TO M:INPUT#1,NP(J,1),NP(J,2),NP(J,3),NP(J,4),T(J):NEXT J
260 IF MW>0 THEN FOR J=1 TO MW:INPUT#1,MP(J,1),MP(J,2),AW(J),QW(J):NEXT J
270 CLOSE 1
280 FOR I=1 TO 4:FOR J=1 TO 3:K=I+J-1:IF K>4 THEN K=K-4
290 KS(I,J)=K:NEXT J,I
300 PRINT"Generation of pointer matrix"
310 FOR I=1 TO N:KP(I,1)=I:KP(I,NZ)=1:NEXT I:IC=CSRLIN
320 FOR J=1 TO M:LOCATE IC,1,0:PRINT"   Element ...... ";J
330 FOR K=1 TO 4:KK=NP(J,K):FOR L=1 TO 4:LL=NP(J,L)
340 IA=0:FOR II=1 TO KP(KK,NZ):IF KP(KK,II)=LL THEN IA=1
350 NEXT II:IF IA=0 THEN KB=KP(KK,NZ)+1:KP(KK,NZ)=KB:KP(KK,KB)=LL
360 IF KB=NZ THEN 820
370 NEXT L,K,J
380 FOR I=1 TO N:FOR J=1 TO MW:FOR II=1 TO 2:IF MP(J,II)=I THEN 400
390 NEXT II:GOTO 430
400 FOR II=1 TO 2:IJ=MP(J,II):FOR L=1 TO KP(I,NZ):IF KP(I,L)=IJ THEN 420
410 NEXT L:K=KP(I,NZ)+1:KP(I,K)=IJ:KP(I,NZ)=K:IF K=NZ THEN 820
420 NEXT II
430 NEXT J,I
440 PRINT:PRINT"Generation of system matrix":EE=.000001:IC=CSRLIN
450 FOR J=1 TO M:LOCATE IC,1,0:PRINT"   Element ...... ";J:FOR KW=1 TO 4
460 FOR I=1 TO 3:K=NP(J,KS(KW,I)):XJ(I)=X(K):YJ(I)=Y(K):NEXT I
470 B(1)=YJ(2)-YJ(3):B(2)=YJ(3)-YJ(1):B(3)=YJ(1)-YJ(2)
480 C(1)=XJ(3)-XJ(2):C(2)=XJ(1)-XJ(3):C(3)=XJ(2)-XJ(1)
490 D=ABS(XJ(1)*B(1)+XJ(2)*B(2)+XJ(3)*B(3)):IF D<EE THEN 560
500 D=1/(4*D*T(J))
510 FOR K=1 TO 3:KK=NP(J,KS(KW,K)):II=KP(KK,NZ):FOR LL=1 TO II:L=1
520 KV=KS(KW,L):IF NP(J,KV)=KP(KK,LL) THEN 540
530 L=L+1:IF L<4 THEN 520 ELSE 550
540 P(KK,LL)=P(KK,LL)+D*(B(K)*B(L)+C(K)*C(L))
550 NEXT LL,K
560 NEXT KW,J
570 FOR J=1 TO MW:KK=MP(J,1):P(KK,1)=P(KK,1)+AW(J):Q(KK)=Q(KK)+AW(J)*QW(J)
580 II=KP(KK,NZ):FOR LL=2 TO II
590 IF MP(J,2)=KP(KK,LL) THEN P(KK,LL)=P(KK,LL)-AW(J)
600 NEXT LL:KK=MP(J,2):P(KK,1)=P(KK,1)+AW(J):Q(KK)=Q(KK)-AW(J)*QW(J)
610 II=KP(KK,NZ):FOR LL=2 TO II
620 IF MP(J,1)=KP(KK,LL) THEN P(KK,LL)=P(KK,LL)-AW(J)
630 NEXT LL
640 NEXT J:PRINT:PRINT"Solution of equations":EE=.000001:EE=EE*EE
650 IC=CSRLIN:IT=1:FOR I=1 TO N:U(I)=0:IF IP(I)>0 THEN 670
660 U(I)=Q(I):FOR J=1 TO KP(I,NZ):U(I)=U(I)-P(I,J)*F(KP(I,J)):NEXT J
670 V(I)=U(I):NEXT I:UU=0:FOR I=1 TO N:UU=UU+U(I)*U(I):NEXT I
680 LOCATE IC,1,0:PRINT"   Iteration .... ";IT:FOR I=1 TO N:W(I)=0
690 FOR J=1 TO KP(I,NZ):W(I)=W(I)+P(I,J)*V(KP(I,J)):NEXT J,I
700 VW=0:FOR I=1 TO N:VW=VW+V(I)*W(I):NEXT I
710 AA=UU/VW:FOR I=1 TO N:IF IP(I)>0 THEN 730
720 F(I)=F(I)+AA*V(I):U(I)=U(I)-AA*W(I)
730 NEXT I:WW=0:FOR I=1 TO N:WW=WW+U(I)*U(I):NEXT I
740 BB=WW/UU:FOR I=1 TO N:V(I)=U(I)+BB*V(I):NEXT I:UU=WW
750 IT=IT+1:IF IT<=2*N AND UU>EE THEN 680
760 PRINT:PRINT"Rewriting datafile ";N$:PRINT
770 OPEN"O",1,N$:PRINT#1,NLX;NLY;SXY;NSCR;N;M;MW
780 FOR I=1 TO N:PRINT#1,X(I);Y(I);IP(I);F(I);Q(I):NEXT I
790 FOR J=1 TO M:PRINT#1,NP(J,1);NP(J,2);NP(J,3);NP(J,4);T(J):NEXT J
800 IF MW>0 THEN FOR J=1 TO MW:PRINT#1,MP(J,1);MP(J,2);AW(J);QW(J):NEXT J
810 CLOSE 1:END
820 PRINT:PRINT"Pointer width too small":PRINT:END
830 CLS:LOCATE 1,26,1:COLOR 0,7:PRINT" Advection using FEM - Part 3 ";
840 COLOR 7,0:PRINT:PRINT:RETURN
