100 DEFINT I-N:KEY OFF:OPTION BASE 1:GOSUB 900
110 PRINT"---  Bear & Verruijt - Groundwater Modeling"
120 PRINT"---  Transport by Dispersion"
130 PRINT"---  Finite Element Method":PRINT"---  Program 12.4"
140 PRINT"---  Quadrangular elements, input by DATA statements"
150 PRINT"---  Solution by Gauss-Seidel iteration"
160 DIM XJ(4),YJ(4),B(3),C(3),D(3),KS(4,3),X(350),Y(350),IP(350)
170 DIM CC(350),CA(350),Q(350),P(350,10),R(350,10),KP(350,10):NZ=10
180 DIM NP(300,4),VX(300),VY(300),D1(300),D2(300)
190 PRINT:PRINT:INPUT"Name of dataset ....... ";N$:PRINT:OPEN"I",#1,N$
200 INPUT#1,NLX,NLY,SXY,NSCR,N,M,DA,DB,DT,NS,EPS,NT,RX
210 FOR I=1 TO N:INPUT#1,X(I),Y(I),CA(I),IP(I):CC(I)=CA(I):Q(I)=0:NEXT I
220 FOR J=1 TO M:INPUT#1,NP(J,1),NP(J,2),NP(J,3),NP(J,4),VX(J),VY(J):NEXT J
230 CLOSE 1
240 XA=X(1):YA=Y(1):XB=XA:YB=YA:FOR I=1 TO N:IF X(I)<XA THEN XA=X(I)
250 IF X(I)>XB THEN XB=X(I)
260 IF Y(I)<YA THEN YA=Y(I)
270 IF Y(I)>YB THEN YB=Y(I)
280 NEXT I:SX=NLX/(XB-XA):SY=SXY*NLY/(YB-YA):IF SY<SX THEN SX=SY
290 SY=SX/SXY:GOSUB 920:FOR J=1 TO M:VV=SQR(VX(J)*VX(J)+VY(J)*VY(J))
300 D1(J)=DA*VV:D2(J)=DB*VV:NEXT J
310 FOR I=1 TO 4:FOR J=1 TO 3:K=I+J-1:IF K>4 THEN K=K-4
320 KS(I,J)=K:NEXT J,I:LOCATE 23,1,0:PRINT"Generation of pointer matrix"
330 FOR I=1 TO N:KP(I,1)=I:KP(I,NZ)=1:NEXT I:EE=.000001
340 FOR J=1 TO M:LOCATE 24,4,0:PRINT"Element ...... ";J;
350 FOR K=1 TO 4:KK=NP(J,K):FOR L=1 TO 4:LL=NP(J,L)
360 IA=0:FOR II=1 TO KP(KK,NZ):IF KP(KK,II)=LL THEN IA=1
370 NEXT II:IF IA=0 THEN KB=KP(KK,NZ)+1:KP(KK,NZ)=KB:KP(KK,KB)=LL
380 IF KB=NZ THEN 890
390 NEXT L,K,J
400 LOCATE 23,1,0:PRINT"Generation of system matrices":FOR J=1 TO M
410 LOCATE 24,4,0:PRINT"Element ...... ";J;"  ";:FOR KW=1 TO 4:ZX=0:ZY=0
420 FOR I=1 TO 3:K=NP(J,KS(KW,I)):XJ(I)=X(K):YJ(I)=Y(K)
430 ZX=ZX+X(K):ZY=ZY+Y(K):NEXT I:ZX=ZX/3:ZY=ZY/3
440 FOR I=1 TO 3:XJ(I)=XJ(I)-ZX:YJ(I)=YJ(I)-ZY:NEXT I
450 VV=SQR(VX(J)*VX(J)+VY(J)*VY(J)):C=VX(J)/VV:S=VY(J)/VV
460 FOR I=1 TO 3:XI=XJ(I):YI=YJ(I):XJ(I)=XI*C+YI*S:YJ(I)=YI*C-XI*S:NEXT I
470 B(1)=YJ(2)-YJ(3):C(1)=XJ(3)-XJ(2):D(1)=XJ(2)*YJ(3)-XJ(3)*YJ(2)
480 B(2)=YJ(3)-YJ(1):C(2)=XJ(1)-XJ(3):D(2)=XJ(3)*YJ(1)-XJ(1)*YJ(3)
490 B(3)=YJ(1)-YJ(2):C(3)=XJ(2)-XJ(1):D(3)=XJ(1)*YJ(2)-XJ(2)*YJ(1)
500 D=D(1)+D(2)+D(3):DD=ABS(D):IF DD<EE THEN 620
510 DA=D1(J)/(4*DD):DB=D2(J)/(4*DD):DC=DD/(12*D):DE=1/(4*(1-EPS)*DD)
520 XX=(XJ(1)*XJ(1)+XJ(2)*XJ(2)+XJ(3)*XJ(3))/12
530 XY=(XJ(1)*YJ(1)+XJ(2)*YJ(2)+XJ(3)*YJ(3))/12
540 YY=(YJ(1)*YJ(1)+YJ(2)*YJ(2)+YJ(3)*YJ(3))/12
550 FOR K=1 TO 3:KK=NP(J,KS(KW,K)):II=KP(KK,NZ):FOR LL=1 TO II:L=1
560 KV=KS(KW,L):IF NP(J,KV)=KP(KK,LL) THEN 580
570 L=L+1:IF L<4 THEN 560 ELSE 610
580 P(KK,LL)=P(KK,LL)+DA*B(K)*B(L)+DB*C(K)*C(L)+DC*B(L)*VV
590 AA=XX*B(K)*B(L)+XY*(B(K)*C(L)+B(L)*C(K))+YY*C(K)*C(L)+D(K)*D(L)
600 R(KK,LL)=R(KK,LL)+DE*AA
610 NEXT LL,K
620 NEXT KW,J:TN=0:FOR IS=1 TO NS:B=1/DT:TN=TN+DT:FOR IT=1 TO NT
630 FOR I=1 TO N:AA=0:IZ=KP(I,NZ):IF IP(I)>0 THEN 680
640 AA=Q(I):FOR J=1 TO IZ:CA=B*R(I,J):L=KP(I,J)
650 AA=AA-(P(I,J)+CA)*CC(L)+CA*CA(L):NEXT J
660 CC(I)=CC(I)+RX*AA/(P(I,1)+B*R(I,1)):AA=EPS*CA(I)
670 IF CC(I)<AA THEN CC(I)=AA
680 NEXT I,IT:FOR I=1 TO N:CA(I)=CA(I)+(CC(I)-CA(I))/(1-EPS):CC(I)=CA(I)
690 NEXT I:GOSUB 920:AA=CA(1):FOR I=1 TO N:IF CA(I)>AA THEN AA=CA(I)
700 NEXT I:DC=AA/5:CA=DC/2:NC=4
710 LOCATE 24,4,0:PRINT"Time ......... ";:PRINT USING"###.###";TN;
720 FOR JC=0 TO NC:CF=CA+JC*DC
730 FOR J=1 TO M:I1=NP(J,1):I2=NP(J,2):I3=NP(J,3):I4=NP(J,4)
740 C1=CC(I1):C2=CC(I2):C3=CC(I3):C4=CC(I4)
750 K=0:IF (C1<=CF AND C2<=CF) OR (C1>=CF AND C2>=CF) THEN 780
760 K=K+1:B(K)=X(I1)+(X(I2)-X(I1))*(CF-C1)/(C2-C1)-XA
770 C(K)=Y(I1)+(Y(I2)-Y(I1))*(CF-C1)/(C2-C1)-YA
780 IF (C2<=CF AND C3<=CF) OR (C2>=CF AND C3>=CF) THEN 810
790 K=K+1:B(K)=X(I2)+(X(I3)-X(I2))*(CF-C2)/(C3-C2)-XA
800 C(K)=Y(I2)+(Y(I3)-Y(I2))*(CF-C2)/(C3-C2)-YA
810 IF (C3<=CF AND C4<=CF) OR (C3>=CF AND C4>=CF) THEN 840
820 K=K+1:B(K)=X(I3)+(X(I4)-X(I3))*(CF-C3)/(C4-C3)-XA
830 C(K)=Y(I3)+(Y(I4)-Y(I3))*(CF-C3)/(C4-C3)-YA
840 IF (C4<=CF AND C1<=CF) OR (C4>=CF AND C1>=CF) THEN 870
850 K=K+1:B(K)=X(I4)+(X(I1)-X(I4))*(CF-C4)/(C1-C4)-XA
860 C(K)=Y(I4)+(Y(I1)-Y(I4))*(CF-C4)/(C1-C4)-YA
870 IF K>1 THEN LINE (SX*B(1),SY*C(1))-(SX*B(2),SY*C(2))
880 NEXT J,JC,IS:A$=INPUT$(1):PRINT:END
890 GOSUB 900:PRINT"Pointer width (NZ) too small.":PRINT:END
900 CLS:LOCATE 1,25,1:COLOR 0,7:PRINT" Dispersion by Finite Elements ";
910 COLOR 7,0:PRINT:PRINT:RETURN
920 SCREEN NSCR:CLS:FOR J=1 TO M:I1=NP(J,1):I2=NP(J,2):I3=NP(J,3):I4=NP(J,4)
930 X1=SX*(X(I1)-XA):Y1=SY*(Y(I1)-YA):X2=SX*(X(I2)-XA):Y2=SY*(Y(I2)-YA)
940 X3=SX*(X(I3)-XA):Y3=SY*(Y(I3)-YA):X4=SX*(X(I4)-XA):Y4=SY*(Y(I4)-YA)
950 LINE (X1,Y1)-(X2,Y2):LINE (X2,Y2)-(X3,Y3)
960 LINE (X3,Y3)-(X4,Y4):LINE (X4,Y4)-(X1,Y1):NEXT J:RETURN
