1000 DEFINT I-N:KEY OFF:OPTION BASE 1:GOSUB 2090
1010 PRINT"---  Bear & Verruijt - Groundwater Modeling"
1020 PRINT"---  Non-steady groundwater flow in vertical plane"
1030 PRINT"---  Fresh and salt water with sharp interface"
1040 PRINT"---  Program 13.1"
1050 PRINT"---  Upconing due to a single well":PRINT
1060 DIM X(360),Y(360),NT(360),NM(361),F(360),Q(360),KP(3000),P(3000)
1070 DIM T(320),NP(320,4),PX(320),PY(320),U(360),V(360),W(360)
1080 DIM B(3),C(3),XJ(3),YJ(3),E(3,3),KS(4,3)
1090 DIM FS(21),NA(20),NB(20),DX(20),XN(21),YN(21),QX(21),QY(21),NK(21,7)
1100 PRINT:INPUT"Use default input data (Y/N) ";I$:I$=LEFT$(I$,1):PRINT
1110 IF I$="n" OR I$="N" THEN I$="N":GOTO 1140
1120 I$="Y":WW=400:HT=37.5:H1=10:H2=17.5:H3=10:NV=20:NW=21:N1=5:N2=8:N3=4
1130 GF=10:GS=10.25:DG=GS-GF:PM=1:PR=.35:QQ=5:GOTO 1280
1140 GOSUB 2090:INPUT"Length of aquifer .............. ";WW
1150 INPUT"Thickness of aquifer ........... ";HT
1160 INPUT"Interface level ................ ";H1
1170 INPUT"Well level ..................... ";H2:H3=HT-H2:H2=H2-H1
1180 INPUT"Horizontal elements (3...20) ... ";NV:NW=NV+1
1190 INPUT"Vertical elements (4...16) ..... ";N6:N5=N6+1
1200 N1=INT(N5*H1/HT+1.1):IF N1<2 THEN N1=2
1210 N3=INT(N5*H3/HT+.1):IF N3<1 THEN N3=1
1220 N2=N5-N1-N3:IF N2<1 THEN N2=1
1230 PRINT"Density of fresh water .........   10.00":GF=10
1240 INPUT"Density of salt water .......... ";GS:DG=GS-GF
1250 INPUT"Permeability/viscosity ......... ";PM
1260 INPUT"Storativity .................... ";PR
1270 INPUT"Discharge of well .............. ";QQ
1280 GOSUB 2090:N5=N1+N2+N3:N6=N5-1:N=N5*NW:M=N6*NV
1290 FOR I=1 TO N5:NT(I*NW)=2:NEXT I
1300 FOR I=1 TO N6:L=(I-1)*NV:K=(I-1)*NW:FOR J=1 TO NV:LL=L+J:KK=K+J
1310 NP(LL,1)=KK:NP(LL,2)=KK+NW:NP(LL,3)=KK+NW+1:NP(LL,4)=KK+1:NEXT J,I
1320 FOR I=1 TO 4:FOR J=1 TO 3:K=I+J-1:IF K>4 THEN K=K-4
1330 KS(I,J)=K:NEXT J,I:PRINT"Generation of pointer vector":W=1
1340 CL=CSRLIN:FOR I=1 TO N:LOCATE CL,3,0:PRINT "Node";I:KP(W)=I:NM(I)=W
1350 K=0:FOR J=1 TO M:FOR H=1 TO 4:IF NP(J,H)=I GOTO 1370
1360 NEXT H:GOTO 1400
1370 FOR H=1 TO 4:G=NP(J,H):FOR L=0 TO K:IF KP(W+L)=G GOTO 1390
1380 NEXT L:K=K+1:KP(W+K)=G
1390 NEXT H
1400 NEXT J:W=W+K+1:NEXT I:PRINT:PRINT"Pointer length =";W:NM(N+1)=W
1410 FOR I=1 TO NW:NK(I,5)=4:NEXT I:NK(1,5)=2:NK(NW,5)=2
1420 L=(N1-2)*NV:FOR I=1 TO NV:NK(I,1)=L+I:NK(I,2)=L+I+NV:NEXT I
1430 L=(N1-2)*NV-1:FOR I=2 TO NV:NK(I,3)=L+I:NK(I,4)=L+I+NV:NEXT I
1440 L=(N1-1)*NV:NK(NW,1)=L:NK(NW,2)=L+NV:NN=W-1:DX(1)=1:DX(2)=1
1450 AA=2:FOR I=3 TO NV:DX(I)=1.4*DX(I-2):AA=AA+DX(I):NEXT I
1460 FOR I=1 TO NV:DX(I)=WW*DX(I)/AA:NEXT I:L=(N1-1)*NW:FOR I=1 TO NV
1470 NA(I)=L+I:NB(I)=L+I+1:NEXT I:FOR I=1 TO N5:L=(I-1)*NW+1:X(L)=0
1480 FOR J=1 TO NV:X(L+J)=X(L+J-1)+DX(J):NEXT J,I:FOR I=1 TO NW
1490 FS(I)=H1:XN(I)=1:YN(I)=0:NEXT I:FOR I=1 TO M:T(I)=PM:NEXT I
1500 SP=DX(1)*PR/(PM*GF):IF I$="Y" THEN SP=5:NS=8:GOTO 1540
1510 PRINT:PRINT"Suggestion for time step :";SP:PRINT
1520 INPUT"Time step .............. ";SP
1530 INPUT"Number of time steps ... ";NS
1540 FOR IS=0 TO NS:IF IS=0 THEN GOSUB 2050 ELSE GOTO 1570
1550 AA=(H2+H3)*GF:L=N1*NW:FOR I=1 TO L:F(I)=AA+(H1-Y(I))*GS:NEXT I
1560 L=L+1:FOR I=L TO N:F(I)=(Y(N)-Y(I))*GF:NEXT I:GOTO 1820
1570 FOR I=1 TO NN:P(I)=0:NEXT I:FOR I=1 TO M:FOR KW=1 TO 4:FOR J=1 TO 3
1580 K=NP(I,KS(KW,J)):XJ(J)=X(K):YJ(J)=Y(K):NEXT J
1590 B(1)=YJ(2)-YJ(3):B(2)=YJ(3)-YJ(1):B(3)=YJ(1)-YJ(2)
1600 C(1)=XJ(3)-XJ(2):C(2)=XJ(1)-XJ(3):C(3)=XJ(2)-XJ(1)
1610 D=T(I)/(4*ABS(XJ(1)*B(1)+XJ(2)*B(2)+XJ(3)*B(3)))
1620 FOR J=1 TO 3:FOR K=1 TO 3:E(J,K)=D*(B(J)*B(K)+C(J)*C(K)):NEXT K,J
1630 FOR J=1 TO 3:G=NP(I,KS(KW,J)):W=NM(G):H=NM(G+1)-W-1:FOR K=0 TO H
1640 FOR L=1 TO 3:IF NP(I,KS(KW,L))=KP(W+K) THEN P(W+K)=P(W+K)+E(J,L)
1650 NEXT L,K,J,KW,I:IT=1:EE=.000001:FOR I=1 TO N:Q(I)=0:NEXT I
1660 L=(N1+N2-1)*NW+1:Q(L)=-QQ:FOR K=1 TO NV:I=NA(K):J=NB(K)
1670 AA=.5*PM*DG*DX(K):Q(I)=Q(I)-AA:Q(J)=Q(J)-AA
1680 AA=.5*PM*GF*DX(K):Q(N-NW+K)=Q(N-NW+K)-AA:Q(N-NV+K)=Q(N-NV+K)-AA
1690 AA=.5*PM*GS*DX(K):Q(K)=Q(K)+AA:Q(K+1)=Q(K+1)+AA:NEXT K
1700 FOR I=1 TO N:H=NM(I):G=NM(I+1)-H-1:U(I)=0:IF NT(I)>1 THEN 1720
1710 U(I)=Q(I):FOR J=0 TO G:U(I)=U(I)-P(H+J)*F(KP(H+J)):NEXT J
1720 V(I)=U(I):NEXT I:UU=0:FOR I=1 TO N:UU=UU+U(I)*U(I):NEXT I
1730 LOCATE 5,54,0:PRINT"Iteration ";IT:LOCATE 6,54,0:PRINT"Error ";UU
1740 FOR I=1 TO N:W(I)=0:H=NM(I):G=NM(I+1)-H-1
1750 FOR J=0 TO G:W(I)=W(I)+P(H+J)*V(KP(H+J)):NEXT J,I
1760 VW=0:FOR I=1 TO N:VW=VW+V(I)*W(I):NEXT I
1770 AA=UU/VW:FOR I=1 TO N:IF NT(I)>1 THEN 1790
1780 F(I)=F(I)+AA*V(I):U(I)=U(I)-AA*W(I)
1790 NEXT I:WT=0:FOR I=1 TO N:WT=WT+U(I)*U(I):NEXT I
1800 BB=WT/UU:FOR I=1 TO N:V(I)=U(I)+BB*V(I):NEXT I:UU=WT
1810 IT=IT+1:IF IT<=N AND UU>EE THEN 1730
1820 FOR J=1 TO M:PX(J)=0:PY(J)=GS:IF J>(N1-1)*NV THEN PY(J)=GF
1830 FOR KW=1 TO 4:FOR K=1 TO 3:L=NP(J,KS(KW,K)):XJ(K)=X(L):YJ(K)=Y(L)
1840 NEXT K:B(1)=YJ(2)-YJ(3):B(2)=YJ(3)-YJ(1):B(3)=YJ(1)-YJ(2)
1850 C(1)=XJ(3)-XJ(2):C(2)=XJ(1)-XJ(3):C(3)=XJ(2)-XJ(1)
1860 AA=4*(XJ(1)*B(1)+XJ(2)*B(2)+XJ(3)*B(3)):FOR K=1 TO 3:L=NP(J,KS(KW,K))
1870 PX(J)=PX(J)+B(K)*F(L)/AA:PY(J)=PY(J)+C(K)*F(L)/AA:NEXT K,KW
1880 PX(J)=-PM*PX(J):PY(J)=-PM*PY(J):NEXT J:FOR I=1 TO NW:QX(I)=0:QY(I)=0
1890 FOR K=1 TO NK(I,5):II=NK(I,K):LL=NK(I,5):QX(I)=QX(I)+PX(II)/LL
1900 QY(I)=QY(I)+PY(II)/LL:NEXT K,I:AA=SP/PR:FOR I=1 TO NV:QX(I)=AA*QX(I)
1910 QY(I)=AA*QY(I):FS(I)=FS(I)+QY(I)-QX(I)*YN(I)/XN(I):NEXT I:GOSUB 2050
1920 FOR I=2 TO NV:AA=DX(I-1)+DX(I):AB=FS(I+1)-FS(I-1)
1930 A1=SQR(AA*AA+AB*AB):XN(I)=AA/A1:YN(I)=AB/A1:NEXT I
1940 SCREEN 2:CLS:SX=639/WW:SY=199/HT
1950 FOR I=1 TO M:FOR J=1 TO 4:JJ=NP(I,J):K=J+1:IF K>4 THEN K=1
1960 KK=NP(I,K):IA=SX*X(JJ):IB=SX*X(KK):JA=199-SY*Y(JJ):JB=199-SY*Y(KK)
1970 LINE(IA,JA)-(IB,JB):NEXT J,I:FOR I=1 TO NV:IA=SX*X(I)+1:IB=SX*X(I+1)
1980 JA=SY*FS(I):JB=SY*FS(I+1):IF IA>=IB THEN 2020
1990 FOR K=IA TO IB:AA=(K-IA)/(IB-IA):BB=JA+AA*(JB-JA)
2000 FOR L=1 TO 20:IC=199*RND(1):IF IC<=BB THEN PSET(K,199-IC)
2010 NEXT L,K
2020 NEXT I:LOCATE 4,54,0:PRINT"Time = ";:PRINT USING"####.###";T;
2030 T=T+SP:B$=INKEY$:IF B$="S" OR B$="s" THEN SCREEN 0:CLS:END
2040 NEXT IS:B$=INPUT$(1):SCREEN 0:CLS:END
2050 FOR I=1 TO NW:A1=FS(I)/(N1-1):A2=(H1+H2-FS(I))/N2:A3=H3/N3
2060 FOR J=1 TO N1:K=I+(J-1)*NW:Y(K)=(J-1)*A1:NEXT J:L=N1+1:LL=N1+N2
2070 FOR J=L TO LL:K=I+(J-1)*NW:Y(K)=FS(I)+(J-L+1)*A2:NEXT J:L=LL+1
2080 FOR J=L TO N5:K=I+(J-1)*NW:Y(K)=H1+H2+(J-L+1)*A3:NEXT J,I:RETURN
2090 CLS:LOCATE 1,26,1:COLOR 0,7:PRINT" Interface in vertical plane ";
2100 COLOR 7,0:PRINT:PRINT:RETURN
