1000 DEFINT I-N:KEY OFF:OPTION BASE 1:GOSUB 2000
1010 PRINT"---  Bear & Verruijt - Groundwater Modeling"
1020 PRINT"---  Regional groundwater flow in coastal aquifer"
1030 PRINT"---  Fresh and salt water with sharp interface"
1040 PRINT"---  Program 13.2"
1050 PRINT"---  Solution by finite elements":PRINT
1060 DIM X(200),Y(200),IP(200),H(200),F(200),HA(200),QF(200),QS(200)
1070 DIM PF(200),PS(200),PA(200,10),PB(200,10),PD(200,10),KP(200,10)
1080 DIM U(200),V(200),W(200),GF(200),GS(200):NS=200:MS=150:NZ=10
1090 DIM B(3),C(3),XJ(3),YJ(3),QA(3,3),QB(3,3),KS(4,3)
1100 DIM NP(150,4),TR(150),FF(150),FS(150),TT(100),RF(100)
1110 IS=1:A$="Reading input data":GOSUB 2040:READ N,M,NS,NC,GF,GS,HT,SS
1120 DG=(GS-GF)/GF:FOR I=1 TO N:READ X(I),Y(I),F(I),H(I),QF(I),QS(I),IP(I)
1130 F(I)=F(I)/DG:HA(I)=H(I):NEXT I
1140 FOR J=1 TO M:READ NP(J,1),NP(J,2),NP(J,3),NP(J,4),TR(J),FF(J),FS(J)
1150 NEXT J:FOR K=1 TO NS:READ TT(K),RF(K):NEXT K
1160 KS(1,1)=1:KS(1,2)=2:KS(1,3)=3:KS(2,1)=2:KS(2,2)=3:KS(2,3)=4
1170 KS(3,1)=3:KS(3,2)=4:KS(3,3)=1:KS(4,1)=4:KS(4,2)=1:KS(4,3)=2
1180 PRINT"Generation of pointer matrix":CL=CSRLIN:FOR I=1 TO N:KP(I,1)=I
1190 KP(I,NZ)=1:NEXT I:FOR J=1 TO M:LOCATE CL,4,0:PRINT"Element ....... ";
1200 PRINT USING "####";J;:FOR K=1 TO 4:KK=NP(J,K):FOR L=1 TO 4:LL=NP(J,L)
1210 IA=0:FOR II=1 TO KP(KK,NZ):IF KP(KK,II)=LL THEN IA=1
1220 NEXT II:IF IA=0 THEN KB=KP(KK,NZ)+1:KP(KK,NZ)=KB:KP(KK,KB)=LL
1230 NEXT L,K,J:DT=TT(IS):GOSUB 2000
1240 IC=1:A$="Step"+STR$(IS):GOSUB 2040:EE=.0000001
1250 FOR I=1 TO N:FOR J=1 TO NZ:PA(I,J)=0:PB(I,J)=0:PD(I,J)=0:NEXT J
1260 PF(I)=RF(IS)*(QF(I)+QS(I)):PS(I)=-RF(IS)*QS(I):NEXT I
1270 PRINT"Generation of system matrix":CL=CSRLIN:FOR J=1 TO M
1280 LOCATE CL,4,0:PRINT"Element ....... ";:PRINT USING "####";J;
1290 FOR KW=1 TO 4:HM=0:FOR I=1 TO 3:K=NP(J,KS(KW,I))
1300 XJ(I)=X(K):YJ(I)=Y(K):HM=HM+H(K)+HA(K):NEXT I:HM=HM/6
1310 B(1)=YJ(2)-YJ(3):B(2)=YJ(3)-YJ(1):B(3)=YJ(1)-YJ(2)
1320 C(1)=XJ(3)-XJ(2):C(2)=XJ(1)-XJ(3):C(3)=XJ(2)-XJ(1)
1330 D=ABS(XJ(1)*B(1)+XJ(2)*B(2)+XJ(3)*B(3)):IF D<EE THEN 1460
1340 FA=DG*TR(J)/(4*D):FB=FA*(HT-HM)/HT
1350 FOR K=1 TO 3:FOR L=1 TO 3:QA(K,L)=B(K)*B(L)+C(K)*C(L)
1360 QB(K,L)=FB*QA(K,L):QA(K,L)=FA*QA(K,L):NEXT L,K
1370 FOR K=1 TO 3:IU=NP(J,KS(KW,K)):IH=KP(IU,NZ):FOR L=1 TO IH:LV=1
1380 KV=KS(KW,LV):IF NP(J,KV)=KP(IU,L) THEN 1400
1390 LV=LV+1:IF LV<4 THEN 1380 ELSE 1420
1400 PA(IU,L)=PA(IU,L)+QA(K,LV):PB(IU,L)=PB(IU,L)+QB(K,LV)
1410 PD(IU,L)=PD(IU,L)+QB(K,LV)
1420 NEXT L,K:FOR I=1 TO 3:K=NP(J,KS(KW,I))
1430 PF(K)=PF(K)+RF(IS)*(FF(J)+FS(J))*D/12:PS(K)=PS(K)-RF(IS)*FS(J)*D/12
1440 PD(K,1)=PD(K,1)+SS*D/(12*DT):PD(K,NZ)=PD(K,NZ)+SS*D*HA(K)/(12*DT)
1450 NEXT I    
1460 NEXT KW,J:PRINT:PRINT:EE=.00001:EE=EE*EE
1470 FOR I=1 TO N:PA(I,NZ)=PA(I,NZ)+PF(I):PD(I,NZ)=PD(I,NZ)+PS(I):NEXT I
1480 PRINT"Solution of equations for F":CL=CSRLIN:IT=1
1490 FOR I=1 TO N:U(I)=0:IF IP(I)>1 THEN 1520
1500 U(I)=PA(I,NZ):FOR J=1 TO KP(I,NZ):K=KP(I,J)
1510 U(I)=U(I)-PA(I,J)*F(K)+PB(I,J)*H(K):NEXT J
1520 V(I)=U(I):NEXT I:UU=0:FOR I=1 TO N:UU=UU+U(I)*U(I):NEXT I
1530 LOCATE CL,4,0:PRINT"Iteration ..... ";:PRINT USING "####";IT
1540 FOR I=1 TO N:W(I)=0:FOR J=1 TO KP(I,NZ)
1550 K=KP(I,J):W(I)=W(I)+PA(I,J)*V(K):NEXT J,I
1560 VW=0:FOR I=1 TO N:VW=VW+V(I)*W(I):NEXT I
1570 AA=UU/VW:FOR I=1 TO N:IF IP(I)>1 THEN 1590
1580 F(I)=F(I)+AA*V(I):U(I)=U(I)-AA*W(I)
1590 NEXT I:WW=0:FOR I=1 TO N:WW=WW+U(I)*U(I):NEXT I
1600 BB=WW/UU:FOR I=1 TO N:V(I)=U(I)+BB*V(I)
1610 NEXT I:UU=WW:IT=IT+1:IF UU>0 THEN E=LOG(UU)/LOG(10) ELSE E=-10
1620 PRINT"   Log(error) .... ";:PRINT USING "####.#";E
1630 IF (UU>EE AND IT<=2*N) THEN 1530
1640 FOR I=1 TO N:GF(I)=-PA(I,NZ):FOR J=1 TO KP(I,NZ)
1650 K=KP(I,J):GF(I)=GF(I)+PA(I,J)*F(K)-PB(I,J)*H(K):NEXT J,I
1660 PRINT:PRINT"Solution of equations for h":CL=CSRLIN:IT=1
1670 FOR I=1 TO N:U(I)=0:IF IP(I)>1 THEN 1700
1680 U(I)=PD(I,NZ):FOR J=1 TO KP(I,NZ):K=KP(I,J)
1690 U(I)=U(I)+PB(I,J)*F(K)-PD(I,J)*H(K):NEXT J
1700 V(I)=U(I):NEXT I:UU=0:FOR I=1 TO N:UU=UU+U(I)*U(I):NEXT I
1710 LOCATE CL,4,0:PRINT"Iteration ..... ";:PRINT USING "####";IT
1720 FOR I=1 TO N:W(I)=0:FOR J=1 TO KP(I,NZ)
1730 K=KP(I,J):W(I)=W(I)+PD(I,J)*V(K):NEXT J,I
1740 VW=0:FOR I=1 TO N:VW=VW+V(I)*W(I):NEXT I
1750 AA=UU/VW:FOR I=1 TO N:IF IP(I)>1 THEN 1770
1760 H(I)=H(I)+AA*V(I):U(I)=U(I)-AA*W(I)
1770 NEXT I:WW=0:FOR I=1 TO N:WW=WW+U(I)*U(I):NEXT I
1780 BB=WW/UU:FOR I=1 TO N:V(I)=U(I)+BB*V(I)
1790 NEXT I:UU=WW:IT=IT+1:IF UU>0 THEN E=LOG(UU)/LOG(10) ELSE E=-10
1800 PRINT"   Log(error) .... ";:PRINT USING "####.#";E
1810 IF (UU>EE AND IT<=2*N) THEN 1710
1820 FOR I=1 TO N:GS(I)=PD(I,NZ):FOR J=1 TO KP(I,NZ)
1830 K=KP(I,J):GS(I)=GS(I)+PB(I,J)*F(K)-PD(I,J)*H(K):NEXT J
1840 GF(I)=GF(I)-GS(I):NEXT I
1850 FOR I=1 TO N:IF H(I)<0 THEN H(I)=0 ELSE IF H(I)>HT THEN H(I)=HT
1860 NEXT I:IC=IC+1:A$="Step"+STR$(IS):IF IC>NC THEN 1880
1870 GOSUB 2000:A$=A$+", cycle"+STR$(IC):GOSUB 2040:GOTO 1250
1880 IS=IS+1:FOR I=1 TO N:HN=H(I)+H(I)-HA(I):HA(I)=H(I):H(I)=HN
1890 IF H(I)<0 THEN H(I)=0 ELSE IF H(I)>HT THEN H(I)=HT
1900 NEXT I:GOSUB 2000:A$="Output":GOSUB 2040:B$="###.###"
1910 FOR I=1 TO N:PRINT "i = ";:PRINT USING"###";I;
1920 PRINT"     f = ";:PRINT USING B$;DG*F(I);
1930 PRINT"     h =";:PRINT USING B$;HA(I);
1940 PRINT"     Qf =";:PRINT USING B$;GF(I);
1950 PRINT"     Qs =";:PRINT USING B$;GS(I)
1960 NEXT I:PRINT"Time = ";TT(IS-1);:GOSUB 2020:GOSUB 2000
1970 IF IS>NS THEN 1990
1980 DT=TT(IS)-TT(IS-1):GOTO 1240
1990 GOSUB 2000:A$="END":GOSUB 2040:END
2000 CLS:LOCATE 1,26,1:COLOR 0,7:PRINT" Regional interface model ";
2010 COLOR 7,0:PRINT:PRINT:RETURN
2020 LOCATE 25,27,0:COLOR 0,7:PRINT"  Touch any key to continue  ";
2030 COLOR 7,0:LOCATE 25,79,1:A$=INPUT$(1):RETURN
2040 COLOR 0,7:PRINT " ";A$;" ";:COLOR 7,0:PRINT:PRINT:RETURN
2050 DATA 22,10,17,3,1000,1025,20,0.4
2060 DATA 0,0,0,5,0,0,2,0,100,0,5,0,0,2
2070 DATA 100,0,0,5,0,0,0,100,100,0,5,0,0,0
2080 DATA 200,0,0,5,0,0,0,200,100,0,5,0,0,0
2090 DATA 300,0,0,5,0,0,0,300,100,0,5,0,0,0
2100 DATA 400,0,0,5,0,0,0,400,100,0,5,0,0,0
2110 DATA 500,0,0,5,0,0,0,500,100,0,5,0,0,0
2120 DATA 600,0,0,5,0,0,0,600,100,0,5,0,0,0
2130 DATA 700,0,0,5,0,0,0,700,100,0,5,0,0,0
2140 DATA 800,0,0,5,0,0,0,800,100,0,5,0,0,0
2150 DATA 900,0,0,5,0,0,0,900,100,0,5,0,0,0
2160 DATA 1000,0,0,5,0,0,0,1000,100,0,5,0,0,0
2170 DATA 1,2,3,4,2000,0.001,0,3,4,5,6,2000,0.001,0
2180 DATA 5,6,7,8,2000,0.001,0,7,8,9,10,2000,0.001,0
2190 DATA 9,10,11,12,2000,0.001,0,11,12,13,14,2000,0.001,0
2200 DATA 13,14,15,16,2000,0.001,0,15,16,17,18,2000,0.001,0
2210 DATA 17,18,19,20,2000,0.001,0,19,20,21,22,2000,0.001,0
2220 DATA 100,1,200,1,300,1,500,1,1000,1,2000,1,3000,1,5000,1
2230 DATA 10000,1,20000,1,30000,1,50000,1,100000,1
2240 DATA 200000,1,300000,1,500000,1,1000000,1
